package cc.fascinated.model.score;

import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import lombok.Getter;

/**
 * @author Fascinated (fascinated7)
 */
@Entity
@Getter
public class TrackedScore {
    /**
     * The ID of the score.
     */
    @Id
    private String scoreId;

    /**
     * The ID of the player who set the score.
     */
    private String playerId;

    /**
     * The ID of the leaderboard.
     */
    private String leaderboardId;

    /**
     * The PP of the score.
     */
    private Double pp;

    /**
     * The rank of the score.
     */
    private Long rank;

    /**
     * The base score of the score.
     */
    private Long score;

    /**
     * The modified score of the score.
     */
    private Long modifiedScore;

    /**
     * The weight of the score.
     */
    private Double weight;

    /**
     * The modifiers of the score.
     */
    private String modifiers;

    /**
     * The multiplier of the score.
     */
    private double multiplier;

    /**
     * The number of misses in the score.
     */
    private Long missedNotes;

    /**
     * The number of bad cuts in the score.
     */
    private Long badCuts;

    /**
     * The highest combo in the score.
     */
    private Long maxCombo;

    /**
     * The accuracy of the score.
     */
    private Double accuracy;

    /**
     * The difficulty the score was set on.
     */
    private String difficulty;

    /**
     * Gets the Tracked Score as a DTO
     */
    public TrackedScoreDTO getAsDTO() {
        return new TrackedScoreDTO(scoreId, playerId, leaderboardId, pp, rank, score, missedNotes, accuracy);
    }
}
